'use strict';

var request = require('request');

function CurrencyController(options) {
  this.node = options.node;
  var refresh = options.currencyRefresh || CurrencyController.DEFAULT_CURRENCY_DELAY;
  this.currencyDelay = refresh * 60000;
  this.exchange_rates = {
    mxbit_usd: 0.00,
    btc_usd: 0.00,
    btc_mxbit: 0.00
  };
  this.timestamp = Date.now();
}

CurrencyController.DEFAULT_CURRENCY_DELAY = 10;

CurrencyController.prototype.index = function(req, res) {
  var self = this;
  var currentTime = Date.now();
  if (self.exchange_rates.mxbit_usd === 0.00 || currentTime >= (self.timestamp + self.currencyDelay)) {
    self.timestamp = currentTime;
    request('https://api.coinmarketcap.com/v1/ticker/bitcoin/?convert=USD', function(err, response, body) {
      if (err) {
        self.node.log.error(err);
      }
      if (!err && response.statusCode === 200) {
          var xrate = JSON.parse(body);
          self.exchange_rates ={
              mxbit_usd: parseFloat(xrate[0].price_usd.replace(/'/g, ''))  * 0.000029,
              btc_usd: parseFloat(xrate[0].price_usd.replace(/'/g, '')),
              btc_mxbit:0.000029
          };
        self.exchange_rates.bitstamp = self.exchange_rates.mxbit_usd; // backwards compatibility
      }
      res.jsonp({
        status: 200,
        data: self.exchange_rates
      });
    });
  } else {
    res.jsonp({
      status: 200,
      data: self.exchange_rates
    });
  }

};

module.exports = CurrencyController;
